var StatusImages = new Array();
StatusImages["NLN"] = "chrome://msnmsgr/skin/status/online.png";
StatusImages["AWY"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BRB"] = "chrome://msnmsgr/skin/status/away.png";
StatusImages["BSY"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["PHN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["LUN"] = "chrome://msnmsgr/skin/status/busy.png";
StatusImages["IDL"] = "chrome://msnmsgr/skin/status/idle.png";
StatusImages["HDN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["FLN"] = "chrome://msnmsgr/skin/status/offline.png";
StatusImages["BLK"] = "chrome://msnmsgr/skin/status/blocked.png"; // Not real protocol status
var Emoticons = new Array();
Emoticons[':D'] = "chrome://msnmsgr/skin/emoticons/bigsmile.png";
Emoticons[':S'] = "chrome://msnmsgr/skin/emoticons/confused.png";
Emoticons[':)'] = "chrome://msnmsgr/skin/emoticons/happy.png";
Emoticons[':('] = "chrome://msnmsgr/skin/emoticons/sad.png";
Emoticons[':O'] = "chrome://msnmsgr/skin/emoticons/suprised.png";
Emoticons[';)'] = "chrome://msnmsgr/skin/emoticons/wink.png";
Emoticons[':|'] = "chrome://msnmsgr/skin/emoticons/disappointed.png";
Emoticons[':P'] = "chrome://msnmsgr/skin/emoticons/stickouttongue.png";

const CHALLENGE = "Q1P7W2E4J9R8U3S5";
const XHTML = "http://www.w3.org/1999/xhtml";

const DEBUG = false;
var nsFOS;

function getMainWindow()
{
    var wmediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
        getService(Components.interfaces.nsIWindowMediator);

    return wmediator.getMostRecentWindow( "msnmsgr:contact-list" );
}

function openPrefsWindow(containerID, paneURL, itemID)
{
    const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
    const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
    const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
    var lastPrefWindow = kWindowMediator.getMostRecentWindow("mozilla:preferences");
    if (lastPrefWindow)
        lastPrefWindow.focus();
    else {
        var features = "chrome,titlebar,resizable=yes";
        openDialog("chrome://communicator/content/pref/pref.xul","PrefWindow", 
                   features, paneURL, containerID, itemID);
    }
}

function openWindowOnce(url, type, features)
{
    const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
    const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
    const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
    var lastPrefWindow = kWindowMediator.getMostRecentWindow(type);
    if (lastPrefWindow)
        lastPrefWindow.focus();
    else {
        window.open(url, type, features);
    }
}

function findOutGoingSessionWindowFor(contact) {
    for (var s in client.Sessions) {
        var ses = client.Sessions[s];
        var con = ses.FindContact(contact);
        if (con) {
            if (ses.ContactsCount() == 1) {
                if (ses._WINDOW) {
                    ses._WINDOW.focus();
                    return null;
                }
            }
        }
    }
    return window.open('chrome://msnmsgr/content/session.xul', '_blank', 'chrome,resizable');
}

function findIncomingSessionWindowFor(contact) {
    for (var s in client.Sessions) {
        var ses = client.Sessions[s];
        var con = ses.FindContact(contact);
        if (con) {
            if (ses.ContactsCount() == 1) {
                if (ses._WINDOW) {
                    return ses._WINDOW;
                }
            }
        }
    }
    return null;
}

function gotoURL(postURL, URL, id) {
    var win = window.open('about:blank');
    var form = win.document.createElement('form');
//    form.setAttribute('action', 'https://loginnet.passport.com/ppsecure/md5auth.srf?lc=1033');
    form.setAttribute('action', postURL);
    form.setAttribute('method', "POST");
    win.document.body.appendChild(form);
    
    function appendInput(n, v) {
        var i = win.document.createElement('input');
        i.setAttribute('type', 'hidden');
        i.setAttribute('name', n);
        i.setAttribute('value', v);
        //alert (n + " = " + v);
        form.appendChild(i);
    }
    
    appendInput('mode', 'ttl');
    appendInput('login', window.client.passport);
    appendInput('username', window.client.passport);
    appendInput('sid', window.client.profile['sid']);
    appendInput('kv', window.client.profile['kv']);
    appendInput('id', id);
    var time = new Date().getTime();
    time /= 1000;
    var sl = time.toFixed(0) - window.client.profile['LoginTime'];
    //alert(window.client.profile['LoginTime'] + '\n' + time.toFixed(0) + '\n' + sl);
    appendInput('sl', sl);
    appendInput('rru', URL);
    appendInput('auth', window.client.profile['MSPAuth']);
    var creds = window.client.profile['MSPAuth'] + sl + window.client.password;
    creds = hex_md5(creds);
    appendInput('creds', creds);
    appendInput('svc', 'mail');
    appendInput('js', 'yes');
    
    form.submit();
}

function ExportContacts() {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

    fp.init(window, "Export Contact list to:", nsIFilePicker.modeSave);
    fp.appendFilters(nsIFilePicker.filterXML | nsIFilePicker.filterAll);

    var res=fp.show();
    if (res!=nsIFilePicker.returnOK)
        return false;

    return true;
}

function CreateContactNode(con, statimg) {
    var ti = document.createElement('treeitem');
    var tr = document.createElement('treerow');
    var tc = document.createElement('treecell');
    var str = ' ' + con.Nickname;
    if ((con.Status != "NLN") && (con.Status != "FLN")) {
        str += " (" + client.bundle.GetStringFromName('StatusMsg' + con.Status) + ")";
    }
    tc.setAttribute('label', ' ' + con.Nickname);
    tc.setAttribute('nickname', con.Nickname);
    tc.setAttribute('id', con.EMail);
    tc.setAttribute('src', statimg);
    ti.setAttribute('tooltiptext', con.Nickname + ' <' + con.EMail + '>');
    
    var tb = document.createElement('textbox');
    tc.appendChild(tb);
    
    tr.appendChild(tc);
    ti.appendChild(tr);
    return ti;
}

function createMessageNode(doc, from, textObj, mymsg) {
    from += ":";
    var msg = doc.createElementNS(XHTML, 'div');
    msg.setAttribute('class', 'InstantMessage');

    var nFrom = doc.createElementNS(XHTML, 'span');
    var fNode = doc.createTextNode(from);
    nFrom.appendChild(fNode);
    
    if (mymsg == true) {
        nFrom.setAttribute('class', 'From FromMe');        
    } else {
        nFrom.setAttribute('class', 'From');
    }

    msg.appendChild(nFrom);
    if (typeof(textObj) == 'string')
        textObj = createMessageContentNode(doc, textObj);
    
    msg.appendChild(textObj);

    return msg;
}

function createMessageContentNode(doc, text, mms) {
    var msg = doc.createElementNS(XHTML, 'span');
    
    if (typeof(mms) == "string") {
        var style = convertXMMStoStyle(mms)
        msg.setAttribute('style', style);
    }
    
    var start = 0;
    for (var i = 0; i < text.length; i++) {
        var letter = text.substr(i, 1);
        if (letter == ':') {
            i++;
            var letter = text.substr(i, 1).toUpperCase();
            if (')(DOSP|'.indexOf(letter) >= 0) {
                //add the text before the emote
                AddText(text.substr(start, i - start - 1));
                start = i + 1;
                //add the emote
                var iNode = document.createElementNS(XHTML, 'img');
                iNode.setAttribute('src', Emoticons[':' + letter]);
                msg.appendChild(iNode);
            }
        }
        else if (letter == ';') {
            i++;
            var letter = text.substr(i, 1).toUpperCase();
            if (letter == ')') {
                //add the text before the emote
                AddText(text.substr(start, i - start - 1));
                start = i + 1;
                //add the emote
                var iNode = document.createElementNS(XHTML, 'img');
                iNode.setAttribute('src', Emoticons[';' + letter]);
                msg.appendChild(iNode);
            }
        }
        else if (letter == '\r') {
            i++;
            var letter = text.substr(i, 1);
            if (letter == '\n') {
                //add the text before the linefeed
                AddText(text.substr(start, i - start - 1));
                start = i + 1;
                //add the linebreak
                var iNode = document.createElementNS(XHTML, 'br');
                msg.appendChild(iNode);                
            }
        }
        else if (letter.toLowerCase() == 'h') {
            if (text.substr(i, 7).toLowerCase() == "http://") {
                AddText(text.substr(start, i - start));
                var r = text.indexOf(' ', i);
                if (r == -1) r = text.length;
                var link = text.substr(i, r - i);
                i = r;
                start = i;
                var iNode = document.createElementNS(XHTML, 'a');
                iNode.setAttribute('href', link);
                iNode.setAttribute('target', '_BLANK');
                iNode.appendChild(doc.createTextNode(link));
                msg.appendChild(iNode);
            }
        }
    }
    if (start != i) {
        AddText(text.substr(start, i - start));
    }
    
    function AddText(t) {
        if (t == '') return
        var tNode = doc.createTextNode(t);
        msg.appendChild(tNode);
    }
    return msg;
}

function createNotifyNode(doc, text) {
    from += ":";
    var msg = doc.createElementNS(XHTML, 'div');
    msg.setAttribute('class', 'NotificationMessage');

    var tNode = doc.createTextNode(text);
    
    msg.appendChild(tNode);
    return msg;
}

function convertXMMStoStyle(mms) {
// X-MMS-IM-Format: FN=Tahoma; EF=B; CO=8000; CS=0; PF=22
    var params = mms.split('; ');
    var style = "";
    var style2 = "";
    for (var i in params) {
        i = params[i];
        var p = i.split('=');
        switch (p[0].toUpperCase()) {
            case 'FN':
                style += 'font-family: "' + unescape(p[1]) + '"; ';
                break;
            case 'EF':
                for (var i = 0; i < p[1].length; i++) {
                    var s = p[1].substr(i, 1);
                    switch (s.toUpperCase()) {
                        case 'B':
                            style += 'font-weight: bold; ';
                            break;
                        case 'I':
                            style += 'font-style: italic; ';
                            break;
                        case 'U':
                            style2 += ' underline';
                            break;
                        case 'S':
                            style2 += ' line-through';
                            break;
                    }
                }
                if (style2 != '')
                    style += 'text-decoration:' + style2 + '; ';
                break;
            case 'CO':
                c = '#000000'.substr(0, 7 - p[1].length) + p[1];
                style += 'color: ' + swapRedBlue(c) + '; ';
                break;
            case 'CS':
                
                break;
            case 'PF':
                
                break;
        }
    }
    return style;
}

function appendAndScroll(parent, node) {
    parent.body.appendChild(node);
    try {
        parent.defaultView.scrollTo(0, parent.body.offsetHeight);
    } catch (ex) {
        alert(ex);
    }
}

function _alert(str) {
    if (typeof(nsFOS) != 'object') return;
    str = "\r\n" + str;// + "\r\n";
    nsFOS.write(str, str.length);
    nsFOS.flush();
//    alert(str);
}

function swapRedBlue (clr) {
    return '#' + clr.substr(5, 2) + clr.substr(3, 2) + clr.substr(1, 2);
}

const kIOServiceProgID = "@mozilla.org/network/io-service;1"; // Taken from /comm/content/communicator/utilityOverlay.js

function CheckOnlineStatus(){
  // This function verify the connection state. If OffLine then ask the user to go Online or not.
  // If the user say Yes then the browser state is change to Online and return True else return false.
  var ioService = Components.classes[kIOServiceProgID]
                            .getService(Components.interfaces.nsIIOService);
  var LocalStrings = window.client.bundle;
  if (ioService.offline) {
      if (confirm(LocalStrings.GetStringFromName("ConfirmOnLine"))) ioService.offline = false;
  }                          
  return !ioService.offline;
}

/// preferences
const PREF_CTRID = "@mozilla.org/preferences-service;1";
const nsIPrefService = Components.interfaces.nsIPrefService;
const nsIPrefBranch = Components.interfaces.nsIPrefBranch;
const nsIPrefBranchInternal = Components.interfaces.nsIPrefBranchInternal;

function LoadPrefs(c) {
    var prefService = Components.classes[PREF_CTRID].getService(nsIPrefService);
    var prefBranch = prefService.getBranch("extensions.msn.");
    
    try {
        c.MMS_FN = prefBranch.getCharPref('Font.Name');
        c.MMS_EF_B = prefBranch.getBoolPref('Font.Bold');
        c.MMS_EF_I = prefBranch.getBoolPref('Font.Italic');
        c.MMS_EF_U = prefBranch.getBoolPref('Font.Underline');
        c.MMS_EF_S = prefBranch.getBoolPref('Font.Strike');
        c.MMS_CO = prefBranch.getCharPref('Font.Color');
        c.GROUP_SORT = prefBranch.getCharPref('Sort_By_Groups');
        c.GROUP_OFFLINE = prefBranch.getCharPref('Group_Offline');
    } catch (ex) {
        SavePrefs(c);
    }
}

function SavePrefs(c) {
    var prefService = Components.classes[PREF_CTRID].getService(nsIPrefService);
    var prefBranch = prefService.getBranch("extensions.msn.");
    
    prefBranch.setCharPref('Font.Name', c.MMS_FN);
    prefBranch.setBoolPref('Font.Bold', c.MMS_EF_B);
    prefBranch.setBoolPref('Font.Italic', c.MMS_EF_I);
    prefBranch.setBoolPref('Font.Underline', c.MMS_EF_U);
    prefBranch.setBoolPref('Font.Strike', c.MMS_EF_S);
    prefBranch.setCharPref('Font.Color', c.MMS_CO);    
    prefBranch.setCharPref('Sort_By_Groups', c.GROUP_SORT);    
    prefBranch.setCharPref('Group_Offline', c.GROUP_OFFLINE);    
}

function getStringBundle(path) {
    var strBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].
        getService(Components.interfaces.nsIStringBundleService);

    return strBundleService.createBundle(path); 
}

function convertToUnicode(asciiStr) {
    return asciiStr;
}